-- | Type inferencer for LOL (λω language).
--
-- __Ressources:__
--
-- * /Top Quality Type Error Messages/, Bastiaan Heeren, 2005,
-- http://www.open.ou.nl/bhr/TopQuality.pdf
--
-- * /Interpreting types as abstract values: a tutorial on Hindley-Milner type inference/,
-- Oleg Kiselyov, Chung-chieh Shan, 2008,
-- http://okmij.org/ftp/Haskell/AlgorithmsH.html#teval
--
-- * /Compositional Type Checking for Hindley-Milner Type Systems with Ad-hoc Polymorphism/,
-- Gergő Érdi, 2011,
-- https://gergo.erdi.hu/projects/tandoori/Tandoori-Compositional-Typeclass.pdf
--
-- All submodules, in a topological order.
module    Language.LOL.Typing
 ( module Language.LOL.Typing.Type
 , module Language.LOL.Typing.Solver
 , module Language.LOL.Typing.Constraint
 , module Language.LOL.Typing.Collect
 , module Language.LOL.Typing.Expr
 ) where

import Language.LOL.Typing.Type
import Language.LOL.Typing.Solver
import Language.LOL.Typing.Constraint
import Language.LOL.Typing.Collect
import Language.LOL.Typing.Expr
